/*
		Shop.cpp : implementation file

        Copyright (C) 2000 Patrick Dughi

        This software may be used and distributed according to the terms
        of the GNU Public License, incorporated herein by reference, located
		as the file gpl.txt in this same directory.

        The author may be reached at dughi@imaxx.net.
.		
		Shop class structure and related functions (load/write/etc)
*/

#include "stdafx.h"
#include "Cbreak.h"
#include "Shop.h"
#include "utils.h"
#include "BuyType.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

Shop::Shop()
{

}

Shop::~Shop()
{

}

int Shop::load_shop(CircleFile *cf)
{
  map<int,Zone_Data>::const_iterator zi;
	BuyType *nb;
	int found=0,bad=0;
  extern World the_world;
  string temp,temp2;
  int type=0;

  /* have to verify that each shp is _in_ a zone */
  for(zi=the_world.zone_list.begin();zi!=the_world.zone_list.end() && !found;zi++) {
	  if(zi->first * 100 <= number && zi->second.top >= number) {
		  found=1;
		}
  }

	if(!found) {
		TRACE0(iprintf("Shop %d not found in a zone.\n",number));
		bad=1;
	}
 
  zone = cf->the_zone;
  cf->get_line(&temp);
	while(!temp.empty() && !cf->eof() && !(temp.at(0) == '-' && temp.at(1) == '1')) {
    item_list.push_back(atoi(temp.c_str()));
		cf->get_line(&temp);
	}
	cf->get_line(&temp);
	profits = atof(temp.c_str());

	cf->get_line(&temp);
	profitb = atof(temp.c_str());

	cf->get_line(&temp);
	while(!temp.empty() && !cf->eof() && !(temp.at(0) == '-' && temp.at(1) == '1')) {
    nb = new BuyType;
		if(temp.find(" ") != -1) {
      nb->obj_type = atoi(temp.substr(0,temp.find(" ")).c_str());
	  	nb->accept_string = temp.substr(temp.find(" ")+1).c_str();
		} else {
			nb->obj_type = atoi(temp.c_str());
			nb->accept_string = "";
		}

		buy_list.push_back(*nb);
		cf->get_line(&temp);
  }

	cf->tilde_read(&temp);
	messages[0] = temp;
	cf->tilde_read(&temp);
	messages[1] = temp;
	cf->tilde_read(&temp);
	messages[2] = temp;
	cf->tilde_read(&temp);
	messages[3] = temp;
	cf->tilde_read(&temp);
	messages[4] = temp;
	cf->tilde_read(&temp);
	messages[5] = temp;
	cf->tilde_read(&temp);
	messages[6] = temp;


	cf->get_line(&temp);
	temper = atoi(temp.c_str());

	cf->get_line(&temp);
	bitvector=ascii2bitvector(temp.c_str());

	cf->get_line(&temp);
	mob_num=atoi(temp.c_str());

	cf->get_line(&temp);
	with_who=ascii2bitvector(temp.c_str());

  cf->get_line(&temp);
	while(!temp.empty() && !cf->eof() && !(temp.at(0) == '-' && temp.at(1) == '1')) {
    room_list.push_back(atoi(temp.c_str()));
		cf->get_line(&temp);
	}
  cf->get_line(&temp);
	time[0] = atoi(temp.c_str());
  cf->get_line(&temp);
	time[1] = atoi(temp.c_str());
  cf->get_line(&temp);
	time[2] = atoi(temp.c_str());
  cf->get_line(&temp);
	time[3] = atoi(temp.c_str());

	return TRUE;
}

int Shop::ascii2bitvector(const char *input)
{
  int i;
	int bitvector=0;

	if(isdigit(input[0])) {
		return (atoi(input));
	}
	for(i=0;i<strlen(input);i++) {
		if(input[i] >= 97 && input[i] <= 122) {
			bitvector |= 1 << (input[i] - 'a');
		} else {
			bitvector |= 1 << ((input[i] - 'A')+26);
		}
	}
	return bitvector;
}

void Shop::bitvector2ascii(char *output, int bitvector)
{
  int i, j = 0;
  char *flags="abcdefghijklmnopqrstuvwxyzABCDEF";

  for (i = 0; flags[i] != '\0'; i++) {
	  if (bitvector & (1 << i)) {
        output[j++] = flags[i];
    }
	}

  if (j == 0) {
    output[j++] = '0';
  }

  output[j]='\0';
  return;
}

extern World the_world;

bool Shop::delete_item(string x)
{
	vector<int>::iterator exd;
  for(exd=item_list.begin();exd != item_list.end();exd++) {
	  if(!_stricmp(iprintf("%d - %s ",*exd,the_world.obj_list[*exd].sdesc.c_str()),x.c_str())) {
		  item_list.erase(exd);
		  return TRUE;
	  }
  }
  return FALSE;

}

bool Shop::delete_room(string x)
{
	vector<int>::iterator exd;
  for(exd=room_list.begin();exd != room_list.end();exd++) {
	  if(!_stricmp(iprintf("%d - %s ",*exd,the_world.room_list[*exd].name.c_str()),x.c_str())) {
		  room_list.erase(exd);
		  return TRUE;
	  }
  }
  return FALSE;

}

extern const char *obj_types[];
bool Shop::delete_buy(string x)
{
  vector<BuyType>::iterator exd;
  for(exd=buy_list.begin();exd != buy_list.end();exd++) {
	  if(!_stricmp(iprintf("%s",obj_types[exd->obj_type]),x.c_str())) {
		  buy_list.erase(exd);
		  return TRUE;
	  }
  }
  return FALSE;
}


bool Shop::write_shop(CircleFile *cfile)
{
  string obuf;
  string temp;
  char buf[33];
  int i;
  vector<int>::const_iterator ii;
  vector<BuyType>::const_iterator bi;

  obuf = iprintf("#%d~\n",number);

	if(!item_list.empty()) {
    for(ii=item_list.begin();ii != item_list.end();ii++) {
      obuf += iprintf("%d\n",*ii);
		}
	}

	obuf += "-1\n";

	obuf += iprintf("%.2f\n%.2f\n",profits,profitb);

	if(!buy_list.empty()) {
    for(bi=buy_list.begin();bi!=buy_list.end();bi++) {
	  	obuf += iprintf("%d %s\n",bi->obj_type,bi->accept_string.c_str());
		}
	}

	obuf += "-1\n";

	for(i=0;i<7;i++) {
		obuf += iprintf("%s~\n",messages[i].c_str());
	}

	obuf += iprintf("%d\n",temper);
  bitvector2ascii(buf,bitvector);
	obuf += iprintf("%s\n%d\n",buf,mob_num);
	bitvector2ascii(buf,with_who);
	obuf += iprintf("%s\n",buf);

	if(!room_list.empty()) {
  	for(ii=room_list.begin();ii != room_list.end();ii++) {
	  	obuf += iprintf("%d\n",*ii);
		}
	}


	obuf += "-1\n";

	obuf += iprintf("%d\n%d\n%d\n%d\n",time[0],time[1],time[2],time[3]);

	return(cfile->write_line(&obuf)); 

}

